import * as i0 from '@angular/core';
import { Pipe, NgModule, InjectionToken, Injectable } from '@angular/core';
import { CommonModule } from '@angular/common';

var Color;
(function (Color) {
    Color[Color["primary"] = 0] = "primary";
    Color[Color["secondary"] = 1] = "secondary";
    Color[Color["success"] = 2] = "success";
    Color[Color["danger"] = 3] = "danger";
    Color[Color["warning"] = 4] = "warning";
    Color[Color["info"] = 5] = "info";
    Color[Color["light"] = 6] = "light";
    Color[Color["dark"] = 7] = "dark";
    Color[Color["body"] = 8] = "body";
    Color[Color["white"] = 9] = "white";
    Color[Color["transparent"] = 10] = "transparent";
})(Color || (Color = {}));

var Position;
(function (Position) {
    Position[Position["top"] = 0] = "top";
    Position[Position["left"] = 1] = "left";
    Position[Position["bottom"] = 2] = "bottom";
    Position[Position["right"] = 3] = "right";
})(Position || (Position = {}));

class BsFontColorPipe {
    transform(color_hex) {
        if (color_hex === undefined || color_hex === null || color_hex.length < 7 || typeof (color_hex) !== 'string') {
            return '#FFFFFF';
        }
        const R_HEX = color_hex.substr(1, 2);
        const G_HEX = color_hex.substr(3, 2);
        const B_HEX = color_hex.substr(5, 2);
        const R_DEC = parseInt(R_HEX, 16);
        const G_DEC = parseInt(G_HEX, 16);
        const B_DEC = parseInt(B_HEX, 16);
        const CONTRAST_HEX = R_DEC * 0.299 + G_DEC * 0.587 + B_DEC * 0.114 > 186 ? '#000000' : '#FFFFFF';
        return CONTRAST_HEX;
    }
}
BsFontColorPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsFontColorPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
BsFontColorPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.0.3", ngImport: i0, type: BsFontColorPipe, name: "bsFontColor" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsFontColorPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'bsFontColor'
                }]
        }] });

class BsFontColorPipeModule {
}
BsFontColorPipeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsFontColorPipeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsFontColorPipeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.3", ngImport: i0, type: BsFontColorPipeModule, declarations: [BsFontColorPipe], imports: [CommonModule], exports: [BsFontColorPipe] });
BsFontColorPipeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsFontColorPipeModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsFontColorPipeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsFontColorPipe
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsFontColorPipe
                    ]
                }]
        }] });

class BsAddPropertiesPipe {
    transform(value, toAdd) {
        const result = Object.assign(value !== null && value !== void 0 ? value : {}, toAdd);
        return result;
    }
}
BsAddPropertiesPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsAddPropertiesPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
BsAddPropertiesPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.0.3", ngImport: i0, type: BsAddPropertiesPipe, name: "bsAddProperties" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsAddPropertiesPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'bsAddProperties'
                }]
        }] });

class BsAddPropertiesModule {
}
BsAddPropertiesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsAddPropertiesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsAddPropertiesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.3", ngImport: i0, type: BsAddPropertiesModule, declarations: [BsAddPropertiesPipe], imports: [CommonModule], exports: [BsAddPropertiesPipe] });
BsAddPropertiesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsAddPropertiesModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsAddPropertiesModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsAddPropertiesPipe
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsAddPropertiesPipe
                    ]
                }]
        }] });

class UcFirstPipe {
    transform(value, ...args) {
        return value[0].toUpperCase() + value.slice(1);
    }
}
UcFirstPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: UcFirstPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
UcFirstPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.0.3", ngImport: i0, type: UcFirstPipe, name: "ucFirst" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: UcFirstPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'ucFirst'
                }]
        }] });

class BsUcFirstPipeModule {
}
BsUcFirstPipeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsUcFirstPipeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsUcFirstPipeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.3", ngImport: i0, type: BsUcFirstPipeModule, declarations: [UcFirstPipe], imports: [CommonModule], exports: [UcFirstPipe] });
BsUcFirstPipeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsUcFirstPipeModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsUcFirstPipeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        UcFirstPipe
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        UcFirstPipe
                    ]
                }]
        }] });

class MonthNamePipe {
    transform(date, ...args) {
        if (date) {
            return date.toLocaleString("default", { month: 'long' });
        }
        else {
            return '';
        }
    }
}
MonthNamePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: MonthNamePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
MonthNamePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.0.3", ngImport: i0, type: MonthNamePipe, name: "monthName" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: MonthNamePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'monthName'
                }]
        }] });

class BsMonthNamePipeModule {
}
BsMonthNamePipeModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsMonthNamePipeModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsMonthNamePipeModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.3", ngImport: i0, type: BsMonthNamePipeModule, declarations: [MonthNamePipe], imports: [CommonModule], exports: [MonthNamePipe] });
BsMonthNamePipeModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsMonthNamePipeModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsMonthNamePipeModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        MonthNamePipe
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        MonthNamePipe
                    ]
                }]
        }] });

class WeekdayNamePipe {
    transform(date, ...args) {
        return date.toLocaleString("default", { weekday: 'short' });
    }
}
WeekdayNamePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: WeekdayNamePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
WeekdayNamePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.0.3", ngImport: i0, type: WeekdayNamePipe, name: "weekdayName" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: WeekdayNamePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'weekdayName'
                }]
        }] });

class BsWeekdayNameModule {
}
BsWeekdayNameModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsWeekdayNameModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsWeekdayNameModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.3", ngImport: i0, type: BsWeekdayNameModule, declarations: [WeekdayNamePipe], imports: [CommonModule], exports: [WeekdayNamePipe] });
BsWeekdayNameModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsWeekdayNameModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsWeekdayNameModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        WeekdayNamePipe
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        WeekdayNamePipe
                    ]
                }]
        }] });

class BsInListPipe {
    transform(items, parameter) {
        return items.some(item => item.id === parameter);
    }
}
BsInListPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsInListPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
BsInListPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "15.0.3", ngImport: i0, type: BsInListPipe, name: "inList" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsInListPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'inList'
                }]
        }] });

class BsInListModule {
}
BsInListModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsInListModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
BsInListModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "15.0.3", ngImport: i0, type: BsInListModule, declarations: [BsInListPipe], imports: [CommonModule], exports: [BsInListPipe] });
BsInListModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsInListModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsInListModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        BsInListPipe
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        BsInListPipe
                    ]
                }]
        }] });

/**
 * Register this provider with a **true** value to enable Development mode for ng-bootstrap.
 * This will make the overlays, which usually close when clicking outside of them,
 * to stay open.
 **/
const BS_DEVELOPMENT = new InjectionToken('BootstrapDevelopment');

class BsCalendarMonthService {
    getWeeks(month) {
        const firstAndLast = this.getFirstAndLastDayOfMonth(month);
        const firstOfMonth = this.getMondayBefore(firstAndLast.first);
        const lastOfMonth = this.getSundayAfter(firstAndLast.last);
        const days = this.dateDiff(firstOfMonth, lastOfMonth) + 1;
        const firstDayOffset = (firstAndLast.first.getDay() + 7 - 1) % 7;
        const allDays = this.generateList(days).map(d => d - firstDayOffset).map(d => {
            const wrongDate = new Date(firstAndLast.first.getFullYear(), firstAndLast.first.getMonth(), firstAndLast.first.getDate() + d);
            const correctDate = new Date(wrongDate.getFullYear(), wrongDate.getMonth(), wrongDate.getDate());
            return {
                date: correctDate,
                dayOfMonth: correctDate.getDate(),
                isInMonth: (correctDate.getFullYear() === month.getFullYear()) && (correctDate.getMonth() === month.getMonth())
            };
        });
        const weeks = this.chunk(allDays, 7);
        const weeksMapped = weeks.map((w, i) => {
            var _a;
            return ({
                number: this.weekOfYear(new Date(month.getFullYear(), month.getMonth(), (_a = w.find(d => d.isInMonth)) === null || _a === void 0 ? void 0 : _a.dayOfMonth)),
                days: w
            });
        });
        return weeksMapped;
    }
    generateList(count) {
        return [...Array(count).keys()];
    }
    dayOfWeekMondayBased(date) {
        const d = date.getDay() - 1;
        if (d < 0) {
            return 6;
        }
        else {
            return d;
        }
    }
    weekOfYear(date) {
        const dateClone = new Date(Date.UTC(date.getFullYear(), date.getMonth(), date.getDate()));
        dateClone.setUTCDate(dateClone.getUTCDate() + 4 - (dateClone.getUTCDay() || 7));
        const yearStart = new Date(Date.UTC(dateClone.getUTCFullYear(), 0, 1));
        const utcDiff = this.toUTC(dateClone) - this.toUTC(yearStart);
        return Math.ceil((utcDiff / (1000 * 60 * 60 * 24) + 1) / 7);
    }
    getFirstAndLastDayOfMonth(date) {
        const first = new Date(date.getFullYear(), date.getMonth(), 1);
        const last = new Date(date.getFullYear(), date.getMonth() + 1, 0);
        return { first, last };
    }
    dateDiff(date1, date2) {
        const utc1 = this.toUTC(date1);
        const utc2 = this.toUTC(date2);
        const msPerDay = 1000 * 60 * 60 * 24;
        return Math.floor((utc2 - utc1) / msPerDay);
    }
    dayOfYear(date) {
        const start = new Date(date.getFullYear(), 0, 0);
        return this.dateDiff(start, date);
    }
    toUTC(date) {
        return Date.UTC(date.getFullYear(), date.getMonth(), date.getDate());
    }
    chunk(items, size) {
        const result = [];
        for (let i = 0; i < items.length; i += size) {
            result.push(items.slice(i, i + size));
        }
        return result;
    }
    getMondayBefore(date) {
        const day = date.getDay(), diff = date.getDate() - day + (day == 0 ? -6 : 1); // adjust when day is sunday
        const monday = new Date(date);
        monday.setDate(diff);
        return monday;
    }
    getSundayAfter(date) {
        const day = date.getDay();
        const sunday = new Date(date);
        if (day !== 0) {
            const diff = date.getDate() + 7 - day;
            sunday.setDate(diff);
        }
        return sunday;
    }
}
BsCalendarMonthService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsCalendarMonthService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
BsCalendarMonthService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsCalendarMonthService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: BsCalendarMonthService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

class EnumService {
    getKeys(en) {
        const items = Object.keys(en);
        const halfLength = items.length / 2;
        return items.slice(halfLength);
    }
    getValues(en) {
        const items = Object.keys(en);
        const halfLength = items.length / 2;
        return items.slice(0, halfLength);
    }
    getItems(en) {
        return this.getKeys(en).map((key) => {
            return {
                key,
                value: en[key],
            };
        });
    }
}
EnumService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: EnumService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
EnumService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: EnumService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "15.0.3", ngImport: i0, type: EnumService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

/**
 * Generated bundle index. Do not edit.
 */

export { BS_DEVELOPMENT, BsAddPropertiesModule, BsAddPropertiesPipe, BsCalendarMonthService, BsFontColorPipe, BsFontColorPipeModule, BsInListModule, BsInListPipe, BsMonthNamePipeModule, BsUcFirstPipeModule, BsWeekdayNameModule, Color, EnumService, MonthNamePipe, Position, UcFirstPipe, WeekdayNamePipe };
//# sourceMappingURL=mintplayer-ng-bootstrap.mjs.map
